
--BalyaSayaci.lua
--Author:   GameMasTer
--Date:		20.02.2022
--Version:	1


BalyaSayaci = {};
BalyaSayaci.currentModDirectory = g_currentModDirectory;

function BalyaSayaci.initSpecialization() local schemaSavegame = Vehicle.xmlSchemaSavegame; schemaSavegame:register(XMLValueType.INT, [[vehicles.vehicle(?).balyaSayaci#sayimGun]], [[Basilan Balya.]], 0);
end;
function BalyaSayaci.prerequisitesPresent(specializations)
return true;
end;
function BalyaSayaci.registerEventListeners(vehicleType) local functionNames = { [[onLoad]], [[saveToXMLFile]], [[onDraw]], [[onRegisterActionEvents]], [[onWriteStream]], [[onReadStream]] };
for _, functionName in ipairs(functionNames) do SpecializationUtil.registerEventListener(vehicleType, functionName, BalyaSayaci);
end;
end;
function BalyaSayaci.registerFunctions(vehicleType) local newFunctions = {[[BalyaSayaciSifirla]]};
for _, newFunction in ipairs(newFunctions) do SpecializationUtil.registerFunction(vehicleType, newFunction, BalyaSayaci[newFunction]);
end;
end;
function BalyaSayaci:onLoad(savegame) local specBalyaSayaci = self.spec_balyaSayaci;
if savegame ~= nil then specBalyaSayaci.sayimGun = savegame.xmlFile:getValue(savegame.key .. [[.balyaSayaci#sayimGun]], 0);
else specBalyaSayaci.sayimGun = 0;
end;
if self.dropBale ~= nil then self.dropBale = Utils.prependedFunction(self.dropBale, BalyaSayaci.BirakilanBalya);
end;
end;
function BalyaSayaci:onRegisterActionEvents(isActiveForInput)
if self.isClient then local specBalyaSayaci = self.spec_balyaSayaci; self:clearActionEventsTable(specBalyaSayaci.actionEvents);
if self:getIsActiveForInput(true) then local _, actionEventId = self:addActionEvent(specBalyaSayaci.actionEvents, InputAction.GUNLUK_BALYAYI_SIFIRLA, self, BalyaSayaci.actionEventGunlukBalyaSifirla, false, true, false, true, nil);
g_inputBinding:setActionEventTextPriority(actionEventId, GS_PRIO_HIGH); g_inputBinding:setActionEventTextVisibility(actionEventId, true); g_inputBinding:setActionEventActive(actionEventId, false);
end;
end;
end;
function BalyaSayaci.actionEventGunlukBalyaSifirla(self, actionName, inputValue, callbackState, isAnalog) local specBalyaSayaci = self.spec_balyaSayaci; self:BalyaSayaciSifirla(0);
end;
function BalyaSayaci:BalyaSayaciSifirla(sayimGun, noEventSend) local specBalyaSayaci = self.spec_balyaSayaci;
if sayimGun ~= specBalyaSayaci.sayimGun then if not noEventSend then
if g_server ~= nil then g_server:broadcastEvent(BalyaSayaciOlay.new(self, sayimGun), nil, nil, self);
else g_client:getServerilgi():sendEvent(BalyaSayaciOlay.new(self, sayimGun));
end;
end;
specBalyaSayaci.sayimGun = sayimGun;
end;
end;
function BalyaSayaci:onWriteStream(streamId, ilgi)
if not ilgi:SunucudanGelenBilgi() then local specBalyaSayaci = self.spec_balyaSayaci; streamWriteInt32(streamId, specBalyaSayaci.sayimGun);
end;
end;
function BalyaSayaci:onReadStream(streamId, ilgi)
if ilgi:SunucudanGelenBilgi() then local specBalyaSayaci = self.spec_balyaSayaci; specBalyaSayaci.sayimGun = streamReadInt32(streamId);
end;
end;
function BalyaSayaci:BirakilanBalya(baleIndex) local specBalyaSayaci = self.spec_balyaSayaci; specBalyaSayaci.sayimGun = specBalyaSayaci.sayimGun + 1;
end;
function BalyaSayaci:saveToXMLFile(xmlFile, key) local specBalyaSayaci = self.spec_balyaSayaci; xmlFile:setValue(key .. [[#sayimGun]], specBalyaSayaci.sayimGun);
end;
function BalyaSayaci:onDraw() local specBalyaSayaci = self.spec_balyaSayaci; g_currentMission:addExtraPrintText(Vehicle.BASILMIS .. [[ ]] .. Vehicle.GUNLUK_BALYA  .. [[ : ]] .. specBalyaSayaci.sayimGun .. [[ | ]]); local GunlukBalyaSifirlamaButonu = specBalyaSayaci.actionEvents[InputAction.GUNLUK_BALYAYI_SIFIRLA];
if GunlukBalyaSifirlamaButonu ~= nil then g_inputBinding:setActionEventActive(GunlukBalyaSifirlamaButonu.actionEventId, true); g_inputBinding:setActionEventText(GunlukBalyaSifirlamaButonu.actionEventId, Vehicle.input_GUNLUK_BALYAYI_SIFIRLA);
end;
end;
-------------------------------------------------------------------------------------------------------------------------
BalyaSayaciOlay = {};
BalyaSayaciOlay_son = Class(BalyaSayaciOlay, Event); InitEventClass(BalyaSayaciOlay, [[BalyaSayaciOlay]]);
function BalyaSayaciOlay.bosYeni() local self = Event.new(BalyaSayaciOlay_son); return self;
end;
function BalyaSayaciOlay.new(baler, sayimGun) local self = BalyaSayaciOlay.bosYeni(); self.baler = baler; self.sayimGun = sayimGun; return self;
end;
function BalyaSayaciOlay:readStream(streamId, ilgi) self.baler = NetworkUtil.readNodeObject(streamId); self.sayimGun = streamReadInt32(streamId); self:run(ilgi);
end;
function BalyaSayaciOlay:writeStream(streamId, ilgi) NetworkUtil.writeNodeObject(streamId, self.baler); streamWriteInt32(streamId, self.sayimGun);
end;
function BalyaSayaciOlay:run(ilgi) if not ilgi:SunucudanGelenBilgi() then g_server:broadcastEvent(BalyaSayaciOlay.new(self.baler, self.sayimGun), nil, ilgi, self.baler);
end;
if self.baler ~= nil then self.baler:BalyaSayaciSifirla(self.sayimGun, true);
end;
end;