--[[
OzellikKaydi.lua

Author:		GameMasTer
Date:		20.02.2022
Version:	1

]]

OzellikKaydi = {};
OzellikKaydi.currentModDirectory = g_currentModDirectory;
local modDesc = loadXMLFile("modDesc", OzellikKaydi.currentModDirectory .. "modDesc.xml"); OzellikKaydi.debugPriority = Utils.getNoNil(getXMLInt(modDesc, "modDesc.registerSpecializations#debugPriority"), 0);
local function printError(errorMessage, isWarning, isInfo) local prefix = "::ErrOR:: ";
if isWarning then prefix = "::WARninG:: "; elseif isInfo then prefix = "::InfO:: ";
end;
print(prefix .. "OzellikKaydi.lua: " .. tostring(errorMessage));
end;
local function printDebug(debugMessage, priority, addString)
if OzellikKaydi.debugPriority >= priority then
local prefix = "";
if addString then prefix = "::DebuG:: OzellikKaydi.lua: ";
end;
print(prefix .. tostring(debugMessage));
end;
end;
local specializationNumber = 0;
while true do local specializationKey = string.format("modDesc.registerSpecializations.registerSpecialization(%d)", specializationNumber);
if not hasXMLProperty(modDesc, specializationKey) then break;
end;
local specializationName = Utils.getNoNil(getXMLString(modDesc, specializationKey .. "#name"), "");
local specializationClassName = Utils.getNoNil(getXMLString(modDesc, specializationKey .. "#className"), "");
local specializationFilename = Utils.getNoNil(Utils.getFilename(getXMLString(modDesc, specializationKey .. "#filename"), OzellikKaydi.currentModDirectory), "");
local searchedSpecializations = string.split(Utils.getNoNil(getXMLString(modDesc, specializationKey .. "#searchedSpecializations"), ""), " ");
local searchedSpecializationsString = "";
local function getSearchedSpecializations(searchedSpecializations) for _, searchedSpecialization in pairs(searchedSpecializations) do if searchedSpecializationsString ~= "" then searchedSpecialization = ", " .. searchedSpecialization;
end;
searchedSpecializationsString = searchedSpecializationsString .. searchedSpecialization;
end;
return searchedSpecializationsString;
end;
printDebug("specializationName =  " .. specializationName .. " specializationClassName " .. specializationClassName .. " specializationFilename = " .. specializationFilename .. " searchedSpecializations = " .. getSearchedSpecializations(searchedSpecializations), 1, true);
if specializationName ~= ""	and specializationClassName ~= "" and specializationFilename ~= "" and fileExists(specializationFilename) and searchedSpecializations ~= ""	then
if g_specializationManager:getSpecializationByName(specializationName) == nil then g_specializationManager:addSpecialization(specializationName, specializationClassName, specializationFilename, true, nil);
for vehicleType, vehicle in pairs(g_vehicleTypeManager.types) do if vehicle ~= nil then for name in pairs(vehicle.specializationsByName) do
for _, searchedSpecialization in pairs(searchedSpecializations) do if string.lower(name) == string.lower(searchedSpecialization) then
local specializationObject = g_specializationManager:getSpecializationObjectByName(specializationName);
if vehicle.specializationsByName[specializationName] == nil then vehicle.specializationsByName[specializationName] = specializationObject; table.insert(vehicle.specializationNames, specializationName); table.insert(vehicle.specializations, specializationObject);
printDebug("Added SpecializatioN _" .. specializationName .. "_ Succsessfully to vehicle typE _" .. vehicleType .. "_._", 1, true);
end;
end;
end;
end;
end;
end;
end;
else
if specializationName == nil then printError("Missing specialization name! Skipping specialization... ", false, false);
elseif specializationClassName == nil then printError("Missing specialization class name! Skipping specialization... '" .. specializationName .. "' anon!", false, false);
elseif specializationFilename == nil then printError("Missing specialization filename! Skipping specialization... '" .. specializationName .. "' anon!", false, false);
elseif searchedSpecializations == nil then printError("Missing searched specialization names! Skipping specialization... '" .. specializationName .. "' anon!", false, false);
end;
end;
specializationNumber = specializationNumber + 1;
end;
delete(modDesc);